package lbms.plugins.mldht.azureus;

import lbms.plugins.mldht.kad.DBItem;

import org.gudy.azureus2.plugins.download.DownloadAnnounceResultPeer;

/**
 * @author Damokles
 *
 */
public class DHTPeer implements DownloadAnnounceResultPeer {

	private static final String	PEER_SOURCE	= "DHT";

	private String				addr;
	private int					port;

	protected DHTPeer (DBItem item) {
		byte[] itemData = item.getData();
		addr = (itemData[0] & 0xFF) + "." + (itemData[1] & 0xFF) + "."
				+ (itemData[2] & 0xFF) + "." + (itemData[3] & 0xFF);
		port = (itemData[4] & 0xFF) << 8 | (itemData[5] & 0xFF);
	}

	/* (non-Javadoc)
	 * @see org.gudy.azureus2.plugins.download.DownloadAnnounceResultPeer#getAddress()
	 */
	public String getAddress () {
		return addr;
	}

	/* (non-Javadoc)
	 * @see org.gudy.azureus2.plugins.download.DownloadAnnounceResultPeer#getPeerID()
	 */
	public byte[] getPeerID () {
		return null;
	}

	/* (non-Javadoc)
	 * @see org.gudy.azureus2.plugins.download.DownloadAnnounceResultPeer#getPort()
	 */
	public int getPort () {
		return port;
	}

	/* (non-Javadoc)
	 * @see org.gudy.azureus2.plugins.download.DownloadAnnounceResultPeer#getProtocol()
	 */
	public short getProtocol () {
		return DownloadAnnounceResultPeer.PROTOCOL_NORMAL;
	}

	/* (non-Javadoc)
	 * @see org.gudy.azureus2.plugins.download.DownloadAnnounceResultPeer#getSource()
	 */
	public String getSource () {
		return PEER_SOURCE;
	}

	/* (non-Javadoc)
	 * @see org.gudy.azureus2.plugins.download.DownloadAnnounceResultPeer#getUDPPort()
	 */
	public int getUDPPort () {
		return 0;
	}

}
