package lbms.plugins.mldht.kad;

/**
 * @author Damokles
 *
 */
public class DBItem {
	private byte[]	item	= new byte[6];
	private long	time_stamp;

	public DBItem () {
		time_stamp = System.currentTimeMillis();
	}

	public DBItem (byte[] ip_port) {
		this();
		System.arraycopy(ip_port, 0, item, 0, item.length);
	}

	public DBItem (byte[] buffer, int offset) {
		this();
		System.arraycopy(buffer, offset, item, 0, item.length);
	}

	public DBItem (DBItem dbItem) {
		this();
		System.arraycopy(dbItem.item, 0, item, 0, item.length);
	}

	/// See if the item is expired
	public boolean expired (long now) {
		return (now - time_stamp >= DHTConstants.MAX_ITEM_AGE);
	}

	/// Get the data of an item
	public byte[] getData () {
		return item;
	}
}
